'  Modul is not a program
'  It only contains necessary subroutines and initilasisation 
'  statements for coomunicating among ucontrolers 
'     The purpose ofyour program is to be coded 
'
'$regfile = "89s8252.dat"
$regfile = "89c2051.dat"
$baud = 1200
$crystal = 12000000
' Message format if n = 8:
'     Stx Adr Cmd P01 P02 P03 Crc Etx
' INDX 1   2   3   .   .   .   .   N
Const N = 8                            'message length 
Const Nminusone = N - 1
Const Nminustwo = N - 2
Dim Xx1(n) As Byte                     'input area
Dim Xx2(n) As Byte                     'buffer area 
Dim Xx3(n) As Byte                     'output and process area 
Dim X1 As Byte
Dim X3 As Byte
Dim Msg As Bit
Declare Sub Sendsr
Print ;

Enable Serial
On Serial Serrut
Reset Msg
X1 = N + 1
' Index X1 to put received bytes to the right place we set 
'       in the way, that interrupt receiving routine will synchronize 
'       on the beginning of message on STX byte 
' set max485 on Receive (for RS232 not necessary)
Reset P1.1

'    //////////////////TIMER0 ////////////////
Config Timer0 = Timer , Gate = Internal , Mode = 1
On Timer0 Timer0isr
Enable Timer0
Load Timer0 , 195
'  load 195 at mode = 1 and crystal = 12 MHz means 50 msec
Dim Seconds As Byte
Dim Minutes As Byte
Dim Hours As Byte
Dim Days As Byte
Seconds = 0
Minutes = 0
Hours = 0
Days = 0
Start Timer0
'    ////////////////////////////////////////
Enable Interrupts
'  Loop of the main programm

Do
  If Seconds >= 60 Then
     Seconds = Seconds - 60
     Incr Minutes
     If Minutes >= 60 Then
        Minutes = Minutes - 60
        Incr Hours
        If Hours >= 24 Then
           Hours = Hours - 24
           Incr Days
        End If
     End If
  End If
........... Here the main program proceeds his work in loop ......



  If Tlgrm = 1 Then
  ' prenesi iz vmesnega podroja v obdelovalno
     For X3 = 1 To N
         Xx3(x3) = Xx2(x3)
     Next
  ' obdelamo telegram
  End If
' in ostale funkcije programa  programirati tukaj ...
'               .....................................
Loop


' ////////////////////////////////////////////////////////////
Serrut:
Dim Swrk1 As Byte
Swrk1 = Inkey()
Scon.1 = 0
' Msg Format:
'     Stx Adr Cmd P01 P02 P03 Crc Etx
' INDX 1   2   3   .   .   .   .   N
   If Swrk1 = 2 And X1 > N Then
' If received byte is 02 and index greater then N, we synchronize  
      For X1 = 2 To N
          Xx1(x1) = 0
      Next
      X1 = 1
   End If

   If X1 <= N Then
      Xx1(x1) = Swrk1
   End If

   If X1 = N And Swrk1 = 3 Then
   ' If it is end of message 
'     If Xx1(2) = Slaveadr Then
'  if program is master and not slave we comment this test 

'        Crc8 check: 
         Swrk1 = 0                                            'tmp
         Xx1(n) = 0                                           'crc
         For X1 = 1 To Nminusone
            Swrk1 = Xx1(n) Xor Xx1(x1) 
            Xx1(n) = Lookup(swrk1 , Crc8)
         Next
     move message to buffer area if CRC8 OK   
         If Swrk1 = 0 Then
            For X1 = 1 To N
                Xx2(x1) = Xx1(x1)
            Next
            Xx2(n) = 3
            Set Msg 
         End If
'     End If
  End If
  Incr X1
Return
' ////////////////////////////////////////////////////////
Sub Sendsr
Xx3(1) = 2
Xx3(n) = 0
Xx3(nminusone) = 0
  calculation of the CRC8 checkbyte
  For X3 = 1 To Nminustwo
     Xx3(n) = Xx3(nminusone) Xor Xx3(x3)        
     Xx3(nminusone) = Lookup(xx3(n) , Crc8)     
  Next      ' Check byte is calculated and put into right place
Xx3(n) = 3                                  'ETX

Disable Interrupts
Reset Scon.1
Set P1.1                  'switch MAX485 to send
  For X3 = 1 To N
     Sbuf = Xx3(x3)
     Bitwait Scon.1 , Set
     Reset Scon.1
  Next
Reset P1.1                'switch MAX485 to receive
Enable Interrupts
End Sub

'////////////////////////////////////////////////////////////////
'---------timer0 interrupt subroutine takes control every 50 msec
Timer0isr:
Dim Ticounter As Byte
'every 50 msec:
Load Timer0 , 195
Incr Ticounter
If Ticounter >= 20 Then
   ' every second
   Ticoutner = 0
   Incr Seconds
End If
Return
'---------timer0 interrupt subroutine - end ----  
'  //////////////////////////////////////////////////////////////
Crc8:
Data 0 , 94 , 188 , 226 , 97 , 63 , 221 , 131 , 194 , 156
Data 126 , 32 , 163 , 253 , 31 , 65 , 157 , 195 , 33 , 127
Data 252 , 162 , 64 , 30 , 95 , 1 , 227 , 189 , 62 , 96
Data 130 , 220 , 35 , 125 , 159 , 193 , 66 , 28 , 254 , 160
Data 225 , 191 , 93 , 3 , 128 , 222 , 60 , 98 , 190 , 224
Data 2 , 92 , 223 , 129 , 99 , 61 , 124 , 34 , 192 , 158
Data 29 , 67 , 161 , 255 , 70 , 24 , 250 , 164 , 39 , 121
Data 155 , 197 , 132 , 218 , 56 , 102 , 229 , 187 , 89 , 7
Data 219 , 133 , 103 , 57 , 186 , 228 , 6 , 88 , 25 , 71
Data 165 , 251 , 120 , 38 , 196 , 154 , 101 , 59 , 217 , 135
Data 4 , 90 , 184 , 230 , 167 , 249 , 27 , 69 , 198 , 152
Data 122 , 36 , 248 , 166 , 68 , 26 , 153 , 199 , 37 , 123
Data 58 , 100 , 134 , 216 , 91 , 5 , 231 , 185 , 140 , 210
Data 48 , 110 , 237 , 179 , 81 , 15 , 78 , 16 , 242 , 172
Data 47 , 113 , 147 , 205 , 17 , 79 , 173 , 243 , 112 , 46
Data 204 , 146 , 211 , 141 , 111 , 49 , 178 , 236 , 14 , 80
Data 175 , 241 , 19 , 77 , 206 , 144 , 114 , 44 , 109 , 51
Data 209 , 143 , 12 , 82 , 176 , 238 , 50 , 108 , 142 , 208
Data 83 , 13 , 239 , 177 , 240 , 174 , 76 , 18 , 145 , 207
Data 45 , 115 , 202 , 148 , 118 , 40 , 171 , 245 , 23 , 73
Data 8 , 86 , 180 , 234 , 105 , 55 , 213 , 139 , 87 , 9
Data 235 , 181 , 54 , 104 , 138 , 212 , 149 , 203 , 41 , 119
Data 244 , 170 , 72 , 22 , 233 , 183 , 85 , 11 , 136 , 214
Data 52 , 106 , 43 , 117 , 151 , 201 , 74 , 20 , 246 , 168
Data 116 , 42 , 200 , 150 , 21 , 75 , 169 , 247 , 182 , 232
Data 10 , 84 , 215 , 137 , 107 , 53