'  Program je sprejemnik in oddajnik-odzivnik,

' Program ima vse podprograme in definicije za komunikacijo po RS485 ali RS232

'$regfile = "89s8252.dat"
$regfile = "89c2051.dat"
$baud = 1200
$crystal = 12000000

' Format telegrama if n = 8:
'     Stx Adr Cmd P01 P02 P03 Crc Etx
' INDX 1   2   3   4   5   6   7   8
Const N = 8                                                   'tevilo bytov telegrama
Const Nminusena = N - 1
Const Nminusdva = N - 2
Dim Xx1(n) As Byte                                            'vhodno podroje
Dim Xx2(n) As Byte                                            'vmesno podroje
Dim Xx3(n) As Byte                                            'izhodno podroje
Dim X1 As Byte
Dim X3 As Byte
Dim Tlgrm As Bit

Declare Sub Poslji

'Dodamo nastavitve potrebne za poiljanje in sprejemanje
Print ;
Enable Serial
On Serial Serrut
Reset Tlgrm
X1 = N + 1
' Indeks za razvrstitev sprejetih znakov v telegram postavimo
'       tako, da se bo interrupt sprejemalna rutina
'       sama sinhronizirala na zacetek telegrama

' postavi max485 na sprejem:  (za rs232 ni potrebno, a ne moti)
Reset P1.1
'    //////////////////TIMER0 ////////////////
Config Timer0 = Timer , Gate = Internal , Mode = 1
On Timer0 Titi
Enable Timer0
Load Timer0 , 195
'  load 195 pri mode = 1 je 50 ms
Dim Sekunde As Byte
Dim Minute As Byte
Dim Ure As Byte
Dim Dnevi As Byte
Sekunde = 0
Start Timer0
'    ////////////////////////////////////////

Enable Interrupts
'Zanka glavnega programa
  Cls
Do
  If Sekunde >= 60 Then
     Sekunde = 0
     Incr Minute
     If Minute >= 60 Then
        Minute = 0
        Incr Ure
        If Ure >= 24 Then
           Ure = 0
           Incr Dnevi
        End If
     End If
  End If


  If Tlgrm = 1 Then
     Reset Tlgrm
     For X3 = 1 To N
         Xx3(x3) = Xx2(x3)
     Next
     Xx3(2) = "P"
     Locate 2 , 1
     Lcd Chr(xx3(2)) ; Xx3(3) ; "." ; Xx3(4) ; "-" ; Xx3(5);


     Xx3(2) = "V"
     Xx3(3) = Sekunde
     Xx3(4) = Minute
     Xx3(5) = Ure
     Xx3(6) = Dnevi

     Poslji
     Locate 1 , 1
     Lcd Chr(xx3(2)) ; Xx3(3) ; "." ; Xx3(4) ; "-" ; Xx3(5);
  End If
Loop


' ////////////////////////////////////////////////////////////
Serrut:
Dim Swrk1 As Byte
Swrk1 = Inkey()
Scon.1 = 0
' Format telegrama:
'     Stx Adr Cmd P01 P02 P03 Crc Etx
' INDX 1   2   3   4   5   6   7   8
   If Swrk1 = 2 And X1 > N Then
' e je sprejeti znak start text in indeks izven tabele se sihroniziramo
      For X1 = 2 To N
          Xx1(x1) = 0
      Next
      X1 = 1
   End If

   If X1 <= N Then
      Xx1(x1) = Swrk1
   End If

   If X1 = N And Swrk1 = 3 Then
   ' e je konec telegrama
'     If Xx1(2) = Slaveadr Then
'        vpraanje, ali je telegram namenjen temu sunju po potrebi spremenimo
'        v komentar
'        Sledi crc preverjanje
         Swrk1 = 0                                            'tmp
         Xx1(n) = 0                                           'crc
         For X1 = 1 To Nminusena
            Swrk1 = Xx1(n) Xor Xx1(x1)                        'Tmp = Crc Xor Bd(i)
            Xx1(n) = Lookup(swrk1 , Crc8)                     'Crc = Lookup(tmp , Crc8)
         Next
         If Swrk1 = 0 Then
            For X1 = 1 To N
                Xx2(x1) = Xx1(x1)
            Next
            Xx2(n) = 3
            Set Tlgrm
         End If
'     End If
  End If

  Incr X1
Return
' ////////////////////////////////////////////////////////

Sub Poslji


Xx3(1) = 2
Xx3(n) = 0
Xx3(nminusena) = 0
  For X3 = 1 To Nminusdva
     Xx3(n) = Xx3(nminusena) Xor Xx3(x3)                      'Tmp = Crc Xor Bd(i)
     Xx3(nminusena) = Lookup(xx3(n) , Crc8)                   'Crc = Lookup(tmp , Crc8)
  Next
Xx3(n) = 3                                                    'ETX
Disable Interrupts
Reset Scon.1
Set P1.1
  For X3 = 1 To N
     '   oddajmo znak po znak
     Sbuf = Xx3(x3)
     Bitwait Scon.1 , Set
     Reset Scon.1
  Next
Reset P1.1
Enable Interrupts
End Sub
'////////////////////////////////////////////////////////////////
'        ---------timer0 interrupt rutina se aktivira vsakih 50 msec
Titi:
Dim Tistevec As Byte
'vsakih 50 msec:
Load Timer0 , 195
Incr Tistevec
If Tistevec >= 20 Then
   ' vsako sekundo
   Tistevec = 0
   Incr Sekunde
End If
Return
'         ---------timer0 interrupt    rutina  --------------  konec
'  //////////////////////////////////////////////////////////////
Crc8:
Data 0 , 94 , 188 , 226 , 97 , 63 , 221 , 131 , 194 , 156
Data 126 , 32 , 163 , 253 , 31 , 65 , 157 , 195 , 33 , 127
Data 252 , 162 , 64 , 30 , 95 , 1 , 227 , 189 , 62 , 96
Data 130 , 220 , 35 , 125 , 159 , 193 , 66 , 28 , 254 , 160
Data 225 , 191 , 93 , 3 , 128 , 222 , 60 , 98 , 190 , 224
Data 2 , 92 , 223 , 129 , 99 , 61 , 124 , 34 , 192 , 158
Data 29 , 67 , 161 , 255 , 70 , 24 , 250 , 164 , 39 , 121
Data 155 , 197 , 132 , 218 , 56 , 102 , 229 , 187 , 89 , 7
Data 219 , 133 , 103 , 57 , 186 , 228 , 6 , 88 , 25 , 71
Data 165 , 251 , 120 , 38 , 196 , 154 , 101 , 59 , 217 , 135
Data 4 , 90 , 184 , 230 , 167 , 249 , 27 , 69 , 198 , 152
Data 122 , 36 , 248 , 166 , 68 , 26 , 153 , 199 , 37 , 123
Data 58 , 100 , 134 , 216 , 91 , 5 , 231 , 185 , 140 , 210
Data 48 , 110 , 237 , 179 , 81 , 15 , 78 , 16 , 242 , 172
Data 47 , 113 , 147 , 205 , 17 , 79 , 173 , 243 , 112 , 46
Data 204 , 146 , 211 , 141 , 111 , 49 , 178 , 236 , 14 , 80
Data 175 , 241 , 19 , 77 , 206 , 144 , 114 , 44 , 109 , 51
Data 209 , 143 , 12 , 82 , 176 , 238 , 50 , 108 , 142 , 208
Data 83 , 13 , 239 , 177 , 240 , 174 , 76 , 18 , 145 , 207
Data 45 , 115 , 202 , 148 , 118 , 40 , 171 , 245 , 23 , 73
Data 8 , 86 , 180 , 234 , 105 , 55 , 213 , 139 , 87 , 9
Data 235 , 181 , 54 , 104 , 138 , 212 , 149 , 203 , 41 , 119
Data 244 , 170 , 72 , 22 , 233 , 183 , 85 , 11 , 136 , 214
Data 52 , 106 , 43 , 117 , 151 , 201 , 74 , 20 , 246 , 168
Data 116 , 42 , 200 , 150 , 21 , 75 , 169 , 247 , 182 , 232
Data 10 , 84 , 215 , 137 , 107 , 53